# This is a init script to check presence all nessesary packages
# $1 will be passed to ./start.pl

case $1 in
"-h")
	echo This is a init script to check presence all nessesary packages
	echo 'These options are available; the init.sh script uses the same set of options as ./start'
	./start.pl -h | grep -v "^Usage:"   
         exit
	;;
esac

for module in Text::BasicTemplate Time::Local Net::Netmask Net::IMAP::Simple Mail::POP3Client Net::LDAP
do 

perl -M$module -e 1 2>/dev/null || { 
echo "$module perl module is missing";
echo "Please install it using: perl -MCPAN -e 'install $module'"

read -p 'Do you want me to install it? (y|N) : ' answer

[ -z $answer ] && exit 1

if [ $answer == "y" -o $answer == "Y" ]; then
     perl -MCPAN -e "install $module" 
    perl -M$module -e 1 2>/dev/null || { 
      echo "MODULE $module WAS NOT INSTALLED! Please run this script again or install this module manually" 
      exit
}
else
    exit 1
fi 

}

done


echo
read -p 'We are about to configure some parameters. Continue? (y|N) : ' answer

[ -z $answer ] && exit 1

if [ $answer == "y" -o $answer == "Y" ]; then
    ./config.pl
    echo
else
    echo "Exiting... To confugure run ./config.pl and then ./start.pl to copy files in needed places"
    exit 1
fi 


echo
read -p 'We are about to copy configuration files where they needed. Continue? (y|N) : ' answer

[ -z $answer ] && exit 1

if [ $answer == "y" -o $answer == "Y" ]; then
    ./start.pl $1
    echo
else
    echo "Exiting... To copy files and restart services run ./start.pl"
fi 



