#!/usr/bin/perl

# search for IP/MAC address in the group of dhcpd.leases files

use CGI qw/:standard/;
use Time::Local;

$DIR="/var/lib/dhcp/hist/";
$ZCAT="/bin/zcat";

print header, start_html('search DHCP lease info for MAC/IP '),start_form;;
print "Search MAC/IP address" , textfield('addr'),br;
print checkbox(-name=>'search_all',-checked=>0,-value=>1,-label=>"Search in all files");
print br;
my @l=hist_ls($DIR);
my $leases;
my %trows;

print submit,reset,defaults('Clear'),end_form;


if(param()){

print "<hr>";
my $addr = param('addr');

if($addr !~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/ &&
         $addr !~ /[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}/i){

    print "Wrong IP/MAC address $addr<br>";
    print end_html;
    exit;
}

# using "+" as these calls returns 0 or 1
for(@l){
	if( param('search_all') + param($_) ){
        $leases = "$_";

	$addr = join ":",map {sprintf "%02s",lc($_)} split(/:/,$addr) if $addr =~ /[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}/i;

#	$t_rows=search_leases($addr,$leases);
	search_leases($addr,$leases);



	}

}

print "<table border=\"1\"><tbody><TR><TH>MAC Address</TH><TH>IP Address</TH>\
			<TH>Obtained (Local)</TH><TH>Expires (Local)</TH><TH>Client-Hostname</TH></TR>";
	   
my @RRR=();
for (keys %trows){
    @el=split(/\,/,$_);
    push @RRR,[@el];
}

#sorting by start time
@RRR =  map {$_->[1]} sort {$b->[0] cmp $a->[0]} map { [$_->[2], $_] } @RRR;

# printing table rows
foreach $ra (@RRR){

    print "<tr>";
    print  map {"<td>$_</td>"} @{$ra};
    print "</tr>";
  }

print "</tbody></table>";
print "<p><b>Done.</b>";

}


print end_html;


# go over dhcpd.leases.<DATE> files
sub hist_ls
{
my $dir = shift;
my @l;
opendir(DIRH,"$dir") || die "Cant open $dir:$!";

my @f=readdir(DIRH);


# pretty printing file listing as table 
my $col=10;
my $n=0;
for(sort {$b cmp $a} @f){
if($_ =~ /^dhcpd.leases.\d\d\d\d-\d\d-\d\d-\d\d\:\d\d\:\d\d.gz$/){	

	$indx=$n % $col;

	push @{$row{$indx}},$_;
	$n++;

	
	push @l,$_;
	}
}


print  "<table border=1><tbody>";

for (sort (keys %row)){
	print "<tr>";
	foreach $e ( @{$row{$_}} ){
	    ($ee)= ($e =~ /^dhcpd.leases.(\d\d\d\d-\d\d-\d\d-\d\d\:\d\d\:\d\d)/);
		print "<td><font size=1>" . checkbox(-name=>$e,-checked=>0,-value=>1,-label=>"") . "$ee</td></font>";
		}
	print "</tr>\n";
}

print "</tbody></table>";

return @l;
}


# 

sub search_leases
{
my $addr = shift;
my $file = shift;
my %t=();
my $indx=0;
my $l_count=0;
my $rows="";

#print "- $addr $file";
open(F,"$ZCAT $DIR/$file|") || die "Cant open:$file:$!";


while(<F>)
{

    next if /^#/;
    next if /^$/;

    $l_count++ if /^lease (.+) \{/;

    if( /^lease (.+) \{/ ... /^\}$/)
    {
	$ip=$1;
	chomp;
        if( $ip =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/){
	    $indx = "$l_count" . "_" . "$ip";
	    $t{$indx} .= $_;
	}
    }
}
close F;

for (keys %t){

    $line = $t{$_};

    if( $t{$_} =~ /$addr/ ){

	if(($ip)= $line =~/lease (\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/){
	    ;
	}

         if(($y,$m,$d,$hh,$mm,$ss)=$line =~ /starts \d (\d\d\d\d)\/(\d\d)\/(\d\d) (\d\d)\:(\d\d)\:(\d\d)/){

            $stime=timegm($ss,$mm,$hh,$d,$m-1,$y-1900);
	    ($ss,$mm,$hh,$d,$m,$y)=localtime($stime);
	    $start_time = sprintf "%04d-%02d-%02d %02d:%02d:%02d", $y+1900,$m+1,$d,$hh,$mm,$ss;
	}
                                                                                                                                                 
        if(($y,$m,$d,$hh,$mm,$ss)=$line =~ /ends \d (\d\d\d\d)\/(\d\d)\/(\d\d) (\d\d)\:(\d\d)\:(\d\d)/){

            $etime=timegm($ss,$mm,$hh,$d,$m-1,$y-1900);
	    ($ss,$mm,$hh,$d,$m,$y)=localtime($etime);
	    $end_time = sprintf "%04d-%02d-%02d %02d:%02d:%02d", $y+1900,$m+1,$d,$hh,$mm,$ss;
	}
                 
                                                    
        if(($client_hostname)= $line =~/client-hostname (.+)\;/){
        }
                                                                                                                                   
        if(($ether)= $line =~/hardware ethernet ([\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2})/){
        }

	$rr="$ether,$ip,$start_time,$end_time,$client_hostname";

	$trows{$rr}=1;
	
    }
}



}




