#!/usr/bin/perl

use CGI qw/:standard/;
require "../read_config.pl";

my %ESPCFG=();
%ESPCFG=read_config("/etc/netreg/esp.cfg");


my $rep="/var/log/mac-rpt.txt";

if( -f $rep ){

open(F,$rep) || err("Cant open file $rep:$!");

while(<F>){

chomp;
next if /^$/;

($mac,$ip,$t,$n)=split(/\s+/,$_);

$t{$ip}=[$mac,$ip,$t,$n];


}

print header,start_html("List static IP addresses");

$ut=localtime((stat($rep))[9]);

print "List updated: <font color=red>$ut<br></font>";

if($ESPCFG{'email'} ne "" and $ESPCFG{'staticIPnotify'} eq "yes"){
  print "User <font color=green> $ESPCFG{'email'} </font> will be notified<br>";
}

print "<table col=4 border=1>";
print "<th>MAC</th><th>IP</th><th>Detect Time</th><th>DNS</th>";

foreach (sort_by_ip(keys(%t))){

@f=@{$t{$_}};
$time=localtime($f[2]);

print "<tr>";
print "<td>$f[0]</td><td>$f[1]</td><td>$time</td><td>$f[3]</td>";
print "</tr>"; 	

}

print "</table>";
print end_html;

}
else {

err("No such file $rep");

}




sub err{

my $msg=shift;

print header,start_html("List static IP addresses - Error!");
print $msg;
print end_html; 
exit;
}


sub sort_by_ip
{    
return map { $_->[0] }
    sort {
    $a->[1] <=> $b->[1]      ||
    $a->[2] <=> $b->[2]      ||
    $a->[3] <=> $b->[3]      ||
    $a->[4] <=> $b->[4]
    }
map { [$_,(split /\./)]} @_;
}
