#!/usr/bin/perl --
#
#----------------------------------------------------------------------------\
# NetReg 1.3rc2
# Copyright (C) 1999-2002 Peter Valian, Southwestern University
#
# register.cgi -- Student Registration Frontend
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Peter Valian <valianp@southwestern.edu>
# http://www.netreg.org/
#
# Code contributions by:
#
#   Bobby Clark <bobby.clark@eku.edu>, Eastern Kentucky University 
#     IMAP Authentication
#
#----------------------------------------------------------------------------/

use CGI qw/:standard/;

require "variables.pl";
require "subnet.pl";
require "read_config.pl";

# my addition
#require "scan.pl";

%RawInput=();


# this code to prevent reply attack
# then cgi-bin/register_agent.cgi is called

#if( (!defined($ENV{'HTTP_COOKIE'})) and ($ENV{'HTTP_COOKIE'} !~ /scanpassed\=true/) )
#{
#
#$q = new CGI;
#print $q->header(-type  => 'text/html');
#my $before_html_page = $ENV{'DOCUMENT_ROOT'} . "/" . "before.htm";
#
#open(BEFOREHTML,"$before_html_page") || die "Cant open $before_html_page:$!";
#
#while(<BEFOREHTML>){
#    
#    print $_;
#    
#}
#
#    exit;
# }



$host_entry="";

#----------------------------------------------------------------------------\
# Main Function
#----------------------------------------------------------------------------\

my %ESPCFG=();
%ESPCFG=read_config("/etc/netreg/esp.cfg");

parse_subnets();
get_input();
check_input();
#authenticate();
get_host_info();

#scan($IP,$RECORDS{$IP});

append_host_entry();
print_success();
#----------------------------------------------------------------------------/


#############################################################################\
## SUBROUTINES BEGIN
#############################################################################/


#----------------------------------------------------------------------------\
# Get the input from the CGI FORM
#----------------------------------------------------------------------------\
sub get_input {
    my $buffer;
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    @pairs = split(/&/, $buffer);
    foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;

#
# Filter out white space and non-word characters. MW 06/24/04
#

#	$RawInput{$name} = unpack("C*",$value);
	@l=unpack("C*",$value);
	$RawInput{$name} = join("_",@l);

        $value =~ s/\s+/_/g;
        $value =~ s/\W+/_/g; 


	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
    }
}
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Make sure the user is allowed to register and
# we have all the input we need from the user
#----------------------------------------------------------------------------\
sub check_input {
    my $subnet;
    my $found = 0;
    foreach $subnet (values %URSUBS) {
	if (ip_in_subnet($IP,$subnet)) {
	    $found = 1;
	    last;
	}
    }

#    if ((!$FORM{'user'}) || (!$FORM{'pass'}) || ($FORM{'eua_radio'} ne "yes" )) {
#      error("Invalid Login");
#    }

    if (!$FORM{'user'}) {
        error("Invalid Login - Missing Username");
    }

    if (!$FORM{'pass'}) {
        error("Invalid Login - Missing Room Number");
    }

    if ($FORM{'eua_radio'} ne "yes") {
        error("Invalid Login - Must accept EUA");
    }

    if (!$found) {
	error("Permission Denied<P>You are not in my allowable IP range<br>$IP<br>$subnet");
    }



#    if ((!$FORM{'user'}) || (!$FORM{'pass'}) || ($FORM{'eua_radio'} ne "yes" )) {
#      error("Invalid Login");
#    }
  
}
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Use the POP or FTP server for user authentication
# POPStat will return the number of messages in user's INBOX or 
# will return -1 if the connection failed, $ftp->pwd is return null if the
# connection failed.
#----------------------------------------------------------------------------\
sub authenticate {
    if ($AUTH_METHOD eq "POP") {
	$pop=new Mail::POP3Client("$FORM{'user'}","$FORM{'pass'}","$POPSERVER");
	$alive=$pop->POPStat;
	$popmsg=$pop->Message;
	$pop->Close;
	unless ($alive ne "-1") {
	    error("Authentication Failed<P>POP replied:<br>$popmsg");
	}
    } elsif ($AUTH_METHOD eq "FTP") {
	$ftp = Net::FTP->new($FTPSERVER);
	$ftp->login($FORM{'user'}, $FORM{'pass'});
	$ftp->pwd()||error("Authentication Failed<P>Bad Username or Password.");
    } elsif ($AUTH_METHOD eq "IMAP") {
	$imap = new Net::IMAP::Simple( "$IMAPSERVER" );
	$alive = $imap->login( $FORM{'user'}, $FORM{'pass'} );
	$imap->quit();
	unless ($alive) {
	    error("Authentication Failed");
	}
    } else {
	error("No Authentication Method");
    }
}
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# The User has authenticated, get their network & hardware info
#----------------------------------------------------------------------------\
sub get_host_info {
    # Parse through the leases file to get user MAC address based on IP 
    $DONE = 1;
    open(LEASES, "$LEASESPATH/$LEASESFILE") or 
	error( "Could not open lease file: $LEASESPATH/$LEASESFILE" );
    while (<LEASES>) {
	if (!$DONE) {
	    if ($_ =~ /ethernet/) {
		($TRASH, $TRASH, $TRASH, $MAC) = split / +|\;/;
		$RECORDS{$LEASEIP} = uc($MAC);
	    }

	    if($_ =~ /my-vendor-class/ && $_ =~ /MSFT 5/){

		$VENDOR{$LEASEIP} = "Microsoft";

	    }



	    if ($_ =~ /\}/) { $DONE = 1; }
	} elsif (($_ =~ /\{/) && ($_ !~ /\#/)) {
	    ($TRASH, $LEASEIP) = split /\s/;
	    $DONE = 0;
	}
    }
    close (LEASES);
    if (!exists ($RECORDS{$IP})) {
	error("No Lease Found");
    }
}
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Put the date in a usable/sortable format (Y2K Compliant)
# Open dhcpd.conf.new in append mode and add the user as a known host
#----------------------------------------------------------------------------\
  sub append_host_entry {

    # Get the time and put it in the format we want
    ($SEC,$MIN,$HOUR,$DAY,$MO,$YR) = localtime;
    $YR+=1900; $MO++;
    if ($DAY<10) { $DAY="0$DAY"; }
    if ($MO<10) { $MO="0$MO"; }
    if ($HOUR<10) { $HOUR="0$HOUR"; }
    if ($MIN<10) { $MIN="0$MIN"; }
    if ($SEC<10) { $SEC="0$SEC"; }
    $TIME="$HOUR:$MIN:$SEC";



    if( ($ESPCFG{'dhcpvendorcheck'} eq "enabled") && ($VENDOR{$IP} eq "Microsoft") && ($ENV{'HTTP_USER_AGENT'} !~ /WINDOWS NT/i)){
	# HTTP User-Agent header and DHCP vendor option doesn't correlate 
	error("Windows host claims to be a non-Windows machine, probably a Web browser hijacking");

    }

    @RECORDS = (keys %RECORDS);
    # Check if the MAC is already registered
    open (DHCPDCONFNEW, "$DHCPDCONFPATH/$DHCPDCONFFILE.new") or
	error( "Could not open new dhcp configuration file: $DHCPDCONFPATH/$DHCPDCONFFILE.new" );
    while (<DHCPDCONFNEW>) {
      if ($_ =~ /$RECORDS{$IP}/) {
        if ($RECORDS{$IP} eq "") { error("No Registration Required"); }
        else {
          error("Hardware Already Registered<br>Please Reboot Your Computer");
        }
      }
      if ($_ =~ /$FORM{'user'}/) {
        ($TRASH, $HOST) = split /\s/;
        push (@HOSTS, $HOST);
      }
    }
    close(DHCPDCONFNEW);

    my @SHOSTS = (sort { $a <=> $b } @HOSTS);
    ($TRASH, $SERIAL) = split(/-/,$SHOSTS[$#SHOSTS]);
    $SERIAL++;

    check_if_blocked_ether($RECORDS{$IP});


## updating dhcpd.conf.new ##

    open (DHCPDCONFNEW, ">>$DHCPDCONFPATH/$DHCPDCONFFILE.new") or
    error( "Could not write new dhcp configuration file: $DHCPDCONFPATH/$DHCPDCONFFILE.new" );
    
    print DHCPDCONFNEW "host $FORM{'user'}__$FORM{'pass'}-$SERIAL { hardware ethernet ";
    print DHCPDCONFNEW "$RECORDS{$IP} \; }\#$ENV{'HTTP_USER_AGENT'}";
    print DHCPDCONFNEW "\#$YR$MO$DAY $TIME\#$IP\n";

$host_entry = "host $FORM{'user'}-$SERIAL { hardware ethernet " .  "$RECORDS{$IP} \; }\#$ENV{'HTTP_USER_AGENT'}" .  "\#$YR$MO$DAY $TIME\#$IP\n";


    close DHCPDCONFNEW;



  }
#----------------------------------------------------------------------------/


#----------------------------------------------------------------------------\

# The user has been added, print out success message
#----------------------------------------------------------------------------\
  sub print_success {

      print_success_page();
#     print "$host_entry";

    exit;
  }
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Print out the error message and write it to the log file
#----------------------------------------------------------------------------\
  sub error { 
    $ERROR_MSG = shift(@_);
    ($SEC,$MIN,$HOUR,$DAY,$MO,$YR) = localtime;
    $YR+=1900; $MO++;
    if ($HOUR<10) { $HOUR="0$HOUR"; }
    if ($MIN<10) { $MIN="0$MIN"; }
    if ($SEC<10) { $SEC="0$SEC"; }
    $TIME="$HOUR:$MIN:$SEC";
    if ($DAY<10) { $DAY="0$DAY"; }
    if ($MO<10) { $MO="0$MO"; }
    open (ERROR_LOG, ">>$ERROR_LOG");
    print ERROR_LOG "$FORM{'user'} [$YR$MO$DAY $TIME]: $ERROR_MSG\n";
    print ERROR_LOG "\$IP = $IP\n";
    print ERROR_LOG "\$RECORDS{\$IP} = $RECORDS{$IP}\n\n";

    print_custom_header();
    print "<TABLE WIDTH=350 border=0 cellspacing=0 cellpadding=1><TR>";
    print "<TH BGCOLOR=black><table width=348 cellpadding=5";
    print "cellspacing=0 align=center><TR><TH bgcolor=black>";
    print "<font color=white size=5><b>Registration Error</b></FONT></th>";
    print "</tr><tr><th bgcolor=\#DDD7FF>$ERROR_MSG</center><P>";
    print "Please try to register again.  If the problem persists, call the ";
    print "ResNet Administrator.<P>";
    print "</td></tr></table></th></tr></table>";
    print_custom_footer();
    exit;
  }
#----------------------------------------------------------------------------/


sub print_info
{
    my $msg = shift;
    my $color = shift;
    print "<TABLE WIDTH=350 border=0 cellspacing=0 cellpadding=1><TR>";
    print "<TH BGCOLOR=black><table width=348 cellpadding=5";
    print "cellspacing=0 align=center><TR><TH bgcolor=$color>";
    print "<font color=white size=4><b>$msg</b></FONT></th>";
    print "</tr><tr><th bgcolor=\#DDD7FF>$ERROR_MSG</center><P>";
    print "...";
    print "</td></tr></table></th></tr></table>";

}

sub print_success_page
{

    my $exptime;
    my %m = (mins=>'m',hours=>'h',days=>'d',months=>'M',years=>'y',);
my $success = $ENV{'DOCUMENT_ROOT'} . "/" . "success.htm";

open(SUCCESSF,"$success") || die "Cant read $success:$!";

#print "content-type: text/html\n\n";

    if($ESPCFG{'savetimenum'} =~/^\d+$/ &&  $ESPCFG{'savetimetype'} ne ""){

	$exptime = "+" . $ESPCFG{'savetimenum'} . $m{$ESPCFG{'savetimetype'}};

    }
    else {
	
	$exptime = "+2M";	
    }


$name_cookie = cookie(-name=>'ESPname',-value=>$RawInput{'user'},-expires=>$exptime );
$room_cookie = cookie(-name=>'ESProom',-value=>$RawInput{'pass'},-expires=>$exptime );


print header(-type=>'text/html',-cookie=>[$name_cookie,$room_cookie]);

while(<SUCCESSF>){
    $_ =~ s#Assets#/Assets#g;
    print $_;
}

close SUCCESSF;

}





# Print out the error message and write it to the log file
#----------------------------------------------------------------------------\
  sub blocked_msg { 
    $ERROR_MSG = shift(@_);
    print_custom_header();
    print "<TABLE WIDTH=350 border=0 cellspacing=0 cellpadding=1><TR>";
    print "<TH BGCOLOR=black><table width=348 cellpadding=5";
    print "cellspacing=0 align=center><TR><TH bgcolor=black>";
    print "<font color=white size=5><b>Blocked MAC Address</b></FONT></th>";
    print "</tr><tr><th bgcolor=\#DDD7FF>$ERROR_MSG</center><P>";
    print "</td></tr></table></th></tr></table>";
    print_custom_footer();
    exit;
  }
#----------------------------------------------------------------------------/




sub check_if_blocked_ether
{
    my $mac = shift;
    my ($blckmac,@text);

    if( -f "$LEASESPATH/netreg_ether.deny"){
	
	open(BLCKETHERF,"$LEASESPATH/netreg_ether.deny") or 
	    error("Couldn't open $LEASESPATH/netreg_ether.deny: $!");
	
	while(<BLCKETHERF>){
	    chomp;
	    next if /^#/;
	    next if /^$/;
	    ($blckmac,@text) = split(/ /,$_);

	    # normilizing MACs : double digits and upper case
	    $blckmac = join ":",map {sprintf "%02s",uc($_)} split(/:/,$blckmac);
	    $mac = join ":",map {sprintf "%02s",uc($_)} split(/:/,$mac);
	    if($blckmac eq $mac){

		print_custom_header();
		print "<TABLE WIDTH=350 border=0 cellspacing=0 cellpadding=1><TR>";
		print "<TH BGCOLOR=black><table width=348 cellpadding=5";
		print "cellspacing=0 align=center><TR><TH bgcolor=black>";
		print "<font color=white size=5><b>Blocked MAC Address $mac</b></FONT></th>";
		print "</tr><tr><th bgcolor=\#DDD7FF>@text</center><P>";
		print "</td></tr></table></th></tr></table>";
		print_custom_footer();

		exit;
	    }

	}
	
    }

    return 1;

}
