# this is an include code for NetReg+VAT to run a scan
# modified: Apr 22/04

use FileHandle;
use Socket;
use CGI qw/:standard/;
use Net::Netmask;
use LWP::UserAgent;
use Getopt::Std;

STDOUT->autoflush(1);
require "variables.pl";
require "scan_vars.pl";



sub scan 
{

    $|=1;
    my $ip= shift;
    my $mac = shift;
   
    print_custom_header();
#    print_info();
    my $time = localtime;
    print "<b>$time</b><br>($ip,$mac)<br>";
    print_info("Please wait while we are scanning your computer for known vulnerabilities. That may take a couple of minutes.","#00ccc");


$webserver="http://$server:$port";
$url="$webserver/webscan/webscan";

# added "hidden" NETREG parameter to fake tag file 
# otherwise we would have all scans coming from one ip (netreg ip)

$formref = [EMAIL => $email, INCL_SUMMARY => 'ON',SCANTYPE => $scantype,IPLIST => $ip, REP_FORMAT => $rep_format, NETREG => 'YES'];

# requesting a scan as we would do with an ordinary browser

my @res = request_scan($url);


#    my $scan_result = `$SCANNER -i $ip -s $server -p $port -t $scantype  -f $rep_format -T $polling_time`;


if( $res[0] =~ /^Failed/ )
{
    $_= join ' ',@res;

}
else {
    my ($html_report,$nbe_report) = @res;

# waiting for report to show up
# analyzing the nbe report for "Security Hole" message
if( is_vulnerable($nbe_report)){

    $_ = "Vulnerable,$html_report\n";

}
else {

    $_ = "No bugs\n";

}
}



 SWITCH: {
      /^Failed,(.+)/ && do { print_info("The scan <font color=red>failed</font>: $1","#999999"); print_custom_footer(); exit;};
      /^Vulnerable,(.+)/ && do { 

	  print_info("The scan result: this host seems to be vulnerable.
                  Please check your scan report and patch the system." .
	          "<a href=$1>SCAN REPORT</a>","#cc0000");
	  print "Please review the ".
	      "<a href=$1>Scan Report</a><br>".
	      "and run the WindowsUpdate ".
	      "<a href=http://windowsupdate.microsoft.com>http://windowsupdate.microsoft.com</a>";
	  exit;
      };
      /^No bugs/ && do {
	  print_info("Excellent! The system seems to be clean.<br>Proceeding with the registration.","#009900");
      }; 
  }

    print_custom_footer();

}


sub print_info
{
    my $msg = shift;
    my $color = shift;
    print "<TABLE WIDTH=350 border=0 cellspacing=0 cellpadding=1><TR>";
    print "<TH BGCOLOR=black><table width=348 cellpadding=5";
    print "cellspacing=0 align=center><TR><TH bgcolor=$color>";
    print "<font color=white size=4><b>$msg</b></FONT></th>";
    print "</tr><tr><th bgcolor=\#DDD7FF>$ERROR_MSG</center><P>";
    print "...";
    print "</td></tr></table></th></tr></table>";

}



# request a scan from VAT
sub request_scan
{
    my $url = shift;
    my $ua = LWP::UserAgent->new;
    $ua->agent("VAT/0.1 ");
    my $res = $ua->post($url,$formref) || die "error: $!";


    if ($res->is_success) {

	undef $/;
	my $content =  $res->content;
	if( $content =~ /The results will be available from this URL: <a href=(.+)\.html>/)
	{
	 $html_rep="$webserver" . "$1.html";
	 $nbe_rep="$webserver" . "$1.nbe";
     }
	else {
	    my $err = "The scan request is denied ";
	    if ($content =~ /there is a unfinished scan request from your ip/){
	        $err .= "as there is a unfinished scan request from your ip\n";
	    }
	    $err = "Failed," . $err;
	    return ($err);
	}
    }
    else {
	die $res->status_line, " $url\n";
    }

# restore line separator
$/="\n";
    return ($html_rep,$nbe_rep);

}


# check the report
sub is_vulnerable
{
    my $url = shift;
    my $ua = LWP::UserAgent->new;
    $ua->agent("VAT/0.1 ");
    my $res;
    
    while(1) {

    $res = $ua->get($url) || die "error: $!";

# this line won't be displayed as it a comment
# it's used to maintain connection with a Internet Explorer
# as it timeout connections after 5 minutes of inactivity

    print "<!-- scan is in progress -->";

    if ($res->is_success) {

	my $content =  $res->content;
#	print "$content\n";
# if there is no such string in the nbe report we can assume that NBE report was generated
	if ($content !~ /Your scan request has been put in a queue for processing/)
	{
	    return 1 if $content =~ /\|Security Hole\|/;
	    return 0;
	}

    }
    else {
	die $res->status_line, " $url\n";
    }
    
    sleep $polling_time;
}
}




1;
