#!/usr/bin/perl --
#
#----------------------------------------------------------------------------\
# NetReg 1.3rc2
# Copyright (C) 1999-2002 Peter Valian, Southwestern University
#
# register.cgi -- Student Registration Frontend
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Peter Valian <valianp@southwestern.edu>
# http://www.netreg.org/
#
# Code contributions by:
#
#   Bobby Clark <bobby.clark@eku.edu>, Eastern Kentucky University 
#     IMAP Authentication
#
#----------------------------------------------------------------------------/

use CGI qw/:standard/;

require "variables.pl";
require "subnet.pl";


$host_entry="";

#----------------------------------------------------------------------------\
# Main Function
#----------------------------------------------------------------------------\
get_host_info();
check_if_blocked_ether($RECORDS{$IP});

# if previous is false
print_index();


#----------------------------------------------------------------------------\
# Print out the error message and write it to the log file
#----------------------------------------------------------------------------\
  sub error {
    $ERROR_MSG = shift(@_);
    ($SEC,$MIN,$HOUR,$DAY,$MO,$YR) = localtime;
    $YR+=1900; $MO++;
    if ($HOUR<10) { $HOUR="0$HOUR"; }
    if ($MIN<10) { $MIN="0$MIN"; }
    if ($SEC<10) { $SEC="0$SEC"; }
    $TIME="$HOUR:$MIN:$SEC";
    if ($DAY<10) { $DAY="0$DAY"; }
    if ($MO<10) { $MO="0$MO"; }
    open (ERROR_LOG, ">>$ERROR_LOG");
    print ERROR_LOG "$FORM{'user'} [$YR$MO$DAY $TIME]: $ERROR_MSG\n";
    print ERROR_LOG "\$IP = $IP\n";
    print ERROR_LOG "\$RECORDS{\$IP} = $RECORDS{$IP}\n\n";
 
    print_custom_header();
    print "<TABLE WIDTH=350 border=0 cellspacing=0 cellpadding=1><TR>";
    print "<TH BGCOLOR=black><table width=348 cellpadding=5";
    print "cellspacing=0 align=center><TR><TH bgcolor=black>";
    print "<font color=white size=5><b>Blocked MAC Address $RECORDS{$IP} </b></FONT></th>";
    print "</tr><tr><th bgcolor=\#DDD7FF>$ERROR_MSG</center><P>";
    print "</td></tr></table></th></tr></table>";
    print_custom_footer();
    exit;
  }
#----------------------------------------------------------------------------/
 



#----------------------------------------------------------------------------\
# The User has authenticated, get their network & hardware info
#----------------------------------------------------------------------------\
sub get_host_info {
    # Parse through the leases file to get user MAC address based on IP 
    $DONE = 1;
    open(LEASES, "$LEASESPATH/$LEASESFILE") or 
	error( "Could not open lease file: $LEASESPATH/$LEASESFILE" );
    while (<LEASES>) {
	if (!$DONE) {
	    if ($_ =~ /ethernet/) {
		($TRASH, $TRASH, $TRASH, $MAC) = split / +|\;/;
		$RECORDS{$LEASEIP} = uc($MAC);
	    }
	    if ($_ =~ /\}/) { $DONE = 1; }
	} elsif (($_ =~ /\{/) && ($_ !~ /\#/)) {
	    ($TRASH, $LEASEIP) = split /\s/;
	    $DONE = 0;
	}
    }
    close (LEASES);
#    if (!exists ($RECORDS{$IP})) {
#	error("No Lease Found");
#    }
}



sub check_if_blocked_ether
{
    my $mac = shift;
    my ($blckmac,@text);

    if( -f "$LEASESPATH/netreg_ether.deny"){
	
	open(BLCKETHERF,"$LEASESPATH/netreg_ether.deny") or 
	    error("Couldn't open $LEASESPATH/netreg_ether.deny: $!");
	
	while(<BLCKETHERF>){
	    chomp;
	    next if /^#/;
	    next if /^$/;
	    ($blckmac,@text) = split(/ /,$_);
	    # normilizing MACs : double digits and upper case
	    $blckmac = join ":",map {sprintf "%02s",uc($_)} split(/:/,$blckmac);
	    $mac = join ":",map {sprintf "%02s",uc($_)} split(/:/,$mac);
	    if($blckmac eq $mac){
		error("@text");
	    }

	}
	
    }

    return 1;

}


# printing original index
sub print_index
{

	print_custom_header();
	
 
	my $indx= $ENV{'DOCUMENT_ROOT'} . "/" . "index_orig.html";
	
	if( -f $indx){
	    open(INDXF,"$indx") || die "Cant read $indx:$!";
	

	    while(<INDXF>){
		print $_;
	    }
	    
	    close INDXF;
 
	}
	else {

	    print "<html><body>Welcome</body></html>";

	}

	print_custom_footer();
}
