# NetReg Global Variables File -- Version 1.3rc2 (CIDR)
#----------------------------------------------------------------------------\
# Global Variables and modules
#----------------------------------------------------------------------------\

  # Convention: many settings are either "on" (1) or "off" (0).

  $AUTH_METHOD = "FTP";  # possible values: (FTP|POP|IMAP|LDAP)

  if ($AUTH_METHOD eq "POP") { use Mail::POP3Client; }
  elsif ($AUTH_METHOD eq "FTP") { use Net::FTP; }
  elsif ($AUTH_METHOD eq "IMAP") { use Net::IMAP::Simple; }
  elsif ($AUTH_METHOD eq "LDAP") { use Net::LDAP; }

  $POPSERVER = "10.10.10.10";
  $FTPSERVER = "10.10.10.10";
  $IMAPSERVER = "10.10.10.10";

  # List all LDAP servers as a comma-separated list of quoted strings
  @LDAP_SERVERS = ("143.44.65.6","143.44.65.18");

  # How long to wait to failover to next server after a connection failure
  $LDAP_TIMEOUT = 5;

  #----------------------------------------------------------------------#
  # This section is only used if you are *not* using ADS

  # Search base: can be used to restrict which users can register
  $LDAP_BASE = "ou=campus,dc=lawrence,dc=edu";

  # Which attribute must match username, typically cn or uid
  $LDAP_AUTH_ATTR = "uid";

  # Whether to bind anonymously for searches.  If you have a protected 
  # branch of your DIT for students who exercised their FERPA rights,
  # you might then need turn this off and specify credentials for searching
  # that would include access to that branch.
  $LDAP_BIND_ANON = 0;

  # Credentials for non-anonymous binding, if needed
  $LDAP_BIND_CREDENTIALS = "cn=Directory Manager:secretpwd";

  # Set if your LDAP server uses pass-thru authentication, *and*
  # you need to re-map part(s) of the DIT.  For example, the DIT
  # may not match the authentication server's DIT; this allows
  # re-writing of the dn to match.
  $LDAP_USES_PASSTHRU_AUTH = 1;

  # Pairs of elements: lefthand side is what you expect to see returned
  # the search, and the righthand side is what it should be re-mapped 
  # to to match the authenticating server.
  @LDAP_DIT_MAP = ( [ "ou=Public,",  "" ],
                    [ "ou=Private,", "" ]
                  );
  #----------------------------------------------------------------------#

  # Set if you wish to use Microsoft's Active Directory Server as your
  # authentication source
  $LDAP_USE_ADS = 1;

  # ADS can authenticate using user@domain form: specify the domain that
  # should be appended to the username entered in the web form.
  $LDAP_ADS_DOMAIN = "lawrence.edu";

  # Turn on if you want all usernames to be sent as lowercase
  $AUTH_LC_USERNAME = 1;
  $GFX = "/gfx";
  $ADMINPATH = "/cgi-bin/admin";
  $LEASESPATH = "/var/lib/dhcp";
  $LEASESFILE = "dhcpd.leases";
  $DHCPDCONFPATH = "/etc/dhcpd";
  $DHCPDCONFFILE = "dhcpd.conf";
  $ERROR_LOG = "/var/log/register_error.log";
  $SUBNETFILE = "/etc/netreg/subnet.dat";

  # The value of $DDNS_USE_HOST_DECL is only of importance if you
  # employ DDNS.
  # 0 = use the host-supplied hostname to update A and PTR records
  # 1 = use the derived hostname in the dhcpd.conf host declaration
  #     as the hostname in DDNS updates, e.g. username-N.
  $DDNS_USE_HOST_DECL = 1;

  $IP = $ENV{'REMOTE_ADDR'};

  # Set to URL or "" if you do not have an online directory application
  # Remember to URL-encode special characters. Leave <USERNAME> where the
  # username should be substituted into the URL.
  $LDAP_URL = "http://find.lawrence.edu/cgi-bin/directory/campusDirect.cgi" .
              "\?=sid=\&op=viewuser\&selectdn=cn=" . "<USERNAME>" .
              ",ou=public,ou=student,l=Appleton,ou=campus," .
              "dc=lawrence,dc=edu";
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Print out the header HTML
#----------------------------------------------------------------------------\
  sub print_custom_header {
print "content-type: text/html\n\n";
print "<html><body><title>Online Network Registration</title>";
#    print "<html><head><META HTTP-EQUIV=\"EXPIRES\" CONTENT=\"0\">";
#    print "<title>Online Network Registration</title>";
#    print "</head> <body TEXT=\#000000 BGCOLOR=\#FFFFFF LINK=\#705F56";
#    print "VLINK=\#4B4B4B BACKGROUND=/gfx/background.jpg>";
#    print "<table BORDER=0 CELLSPACING=0 CELLPADDING=0 halign=left><tr>";
#    print "<td ALIGN=LEFT VALIGN=TOP WIDTH=185>";
#    print "<center><img src=/gfx/spacer.gif>";
#    print "</center><P> </td> <td ALIGN=LEFT VALIGN=TOP>";
#    print "<center><img SRC=/gfx/lu_logo.gif>";
    print "<p>";
  }
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Print out the footer HTML
#----------------------------------------------------------------------------\
  sub print_custom_footer {
#    print "<P></center></td></tr><tr><td>&nbsp;</td></tr><tr><td></td>";
#    print "<td ALIGN=CENTER>";
#    print "&copy;2003 Lawrence University";
#    print "</td></tr>";
#    print "</table></body></html>";

print "</body></html>";
  }
#----------------------------------------------------------------------------/
1;
