#!/usr/bin/perl

use Getopt::Std;
getopts("LM:X:h");

$DEV=eth0;
$DHCPLEASES="/var/lib/dhcp/dhcpd.leases";


if(!$opt_M){
    help();
    exit;
}
else {
    if( $MAC ne "all"){ $MAC=lc(join '',split(/:/,$opt_M)); }
    
}

if($opt_X eq "all" or $opt_X eq "ALL"){
    exit;
}

$EXCL_MAC=lc(join '',split(/:/,$opt_X));

%t=();
%times=();
$saved_sep = $/;
undef $/;

my $lease_ends,$lease_ip;

open(TC,"tc filter show dev $DEV root|");
@f=split(/filter/,<TC>);
close TC;


$/=$saved_sep;

$rec=0;
foreach (@f){


    $rec++;

    @lines=split(/\n/,$_);

    $ETHER = "";
    foreach $l (@lines){
	if($l =~ /match (.+)\//){$eth{$rec} = $1 . $eth{$rec};}
    }
    
# extructing Ethernet addr
    if($eth{$rec} =~ /(.*)0800/){
	
	$eth{$rec} =$1; 
	$t{$1}=$_;

    }

}

# if we want to just list bandwidth limited MAC addresses
if( $opt_L and $MAC eq "all"){

    foreach (keys(%eth)){
	my $e=$eth{$_};
	(@ea)=$e =~ /(\w\w)(\w\w)(\w\w)(\w\w)(\w\w)(\w\w)/;
	$ETHER = uc(join ':',@ea);
	
	
	$lease_ends="";
	($lease_ip,$lease_ends) = mac_to_ip($ETHER);
#	print "Latest : $lease_ip\n";
	
	if( $lease_ip ne "" ){ 
	    print "$ETHER ($lease_ip lease ends $lease_ends): Bandwidth limiting\n";
	}
	else {
	    print "$ETHER (no ip found): Bandwidth limiting\n"; 
	}
	

    }

    exit;

}



foreach (keys(%eth)){

    my $e=$eth{$_};

    if(($e eq $MAC or $MAC eq "all") and ($e ne $EXCL_MAC)){


#	print "$e\n";

	$rule=$t{$e};

#	print "RULE: $rule\n";

	@r=split(/\s+/, $rule);

	($flowid) = $rule =~ /.+(flowid .+)\n/;
#	print "$e $flowid\n";
	($police) =  $rule =~ /(police .+)\n/;
	@p=split(/\s+/,$police);
# original #	print "POLICE: $e @p[0,4,5,6,7,3]\n";
#	print "POLICE: $e @p[0,2,3,4,5]\n";

	($mac1,$mac2) = $e =~ /(\w\w\w\w\w\w\w\w)(\w\w\w\w)/;

#    print "$e $mac1 - $mac2\n";

# reconstruct the filter rule

     print "tc filter add dev $DEV @r[0..7] match u16 0x0800 0xFFFF at -2 match u16  0x$mac2 0xffff at -4 match u32 0x$mac1 0xffffffff at -8 @p[0,4,5,6,7,3] drop $flowid \n" if $rule =~ /police .+ action drop rate/;

     print "tc filter add dev $DEV @r[0..7] match u16 0x0800 0xFFFF at -2 match u16  0x$mac2 0xffff at -4 match u32 0x$mac1 0xffffffff at -8 @p[0,2,3,4,5] drop $flowid \n" if $rule =~ /police .+ rate .+ action drop/;
	
    }

}


sub help{

    print "Usage: $0 -M MACADDR - report a tc rules for this MAC address
                  $0 -M all -X MACADDR_NOT_TO_REPORT - report for all but this MAC
                  $0 -M all -X all  - not to report any rules, useful for excluding all MAC in netreg_block_mac.sh
\n";

}



# retun an ip for a MAC from dhcpd.leases
sub mac_to_ip
{

    my $addr = shift;
    my $i=0;
    my $lip,$lends;

open(DHCP,"$DHCPLEASES") || die "Cant open $DHCPLEASES:$!";

while(<DHCP>)
{
if( /^lease (.+) \{/ ... /^\}/)
    { 
     $ip=$1;
     if(($ether)=$_=~/hardware ethernet (.+)\;/){
# adding index prefix for sorting later to extract the last ip address assigment
     $t{"$i" . "_" ."$ip"}=$ether;
     $i++;
        }

     if($_ =~ /ends \d+ (.+)\;/){
	 $times{"$i" . "_" ."$ip"}=$1;
     }


   }
}
# sorting to get the latest IP-MAC pair
for (sort {$b<=>$a}(keys %t)){

($lip,$lends)=();

    if(uc($t{$_}) eq uc($addr)) {
	$_ =~ /\d+_(.+)/; 
#        print " Latest : $1\n"; 
	$lip=$1;
	$lends=$times{$_};
	last;
    }
}

#print "==== $lip $lends ==== \n";
return ($lip,$lends);

}
