#!/bin/sh

# This script backs up dhcpd.conf and dhcpd.leases files 
# Before the first use run "ssh -2 user@host ls"
# see README.netreg_backup

NETREGHOSTS="142.151.184.10 142.151.138.14 142.151.170.15"

EXPECT=/usr/bin/expect
SSH=/usr/bin/ssh
TIMESTAMP=`date "+%F %T"`
USER=martynov
[ ! -f ssh_config ] &&  { 
echo "No ssh_config in local directory. It needed to specify Protocol version 2";
exit 
}

# rotation in days
ROTATION=30
DEL_TIMESTAMP=`date "+%F" -d "$ROTATION day ago"`


for ip in $NETREGHOSTS
do

echo "spawn  ssh -2 $USER@$ip /sbin/ifconfig
expect {
"password" {send_user "No"; exit 1}
"Link" { send_user "OK"; exit 0}
"continue" { send_user "No"; exit 1 }
default { send_user "No"; exit 1 }
}
" | $EXPECT -f - >/dev/null && {

[ -d ./$ip ] || {


                 echo "$TIMESTAMP - $ip - Creating directories"
		 mkdir -p ./$ip/dhcpd.leases
		 mkdir -p ./$ip/dhcpd.conf
		 
}

DAY=`date "+%F-%T"`
LEASES="./$ip/dhcpd.leases/dhcpd.leases.$DAY"
CONF="./$ip/dhcpd.conf/dhcpd.conf.$DAY"

scp -F ssh_config -q $USER@$ip:/var/lib/dhcp/dhcpd.leases $LEASES || exit
scp -F ssh_config -q $USER@$ip:/etc/dhcpd/dhcpd.conf $CONF || exit
gzip $LEASES
gzip $CONF

echo "$TIMESTAMP - $ip - Updated"

rm -f ./$ip/dhcpd.leases/dhcpd.leases.$DEL_TIMESTAMP*
rm -f ./$ip/dhcpd.conf/dhcpd.conf.$DEL_TIMESTAMP*

continue
}

echo "$TIMESTAMP - $ip - Failed" 

done


